//
//  iregister.h
//  practical 0
//
//  Created by Mohammadreza Mousavi [mohmou] on 9/5/14.
//  Updated by Masoumeh Taromirad on 11/08/16.
//  Copyright (c) 2014 by Mohammadreza Mousavi [mohmou]. All rights reserved.

#ifndef lab0_iregister_h
#define lab0_iregister_h


/*
 iRegister:
 
 An iRegister is a structure which represents an 32-bit register and
 is equipped with standard operations to modify and display them.
 
 Complete the following functions as described
    
 
    void setBit(int i, iRegsiter * r)
        sets the i'th bit of the iRegister (to 1),
 
    void resetBit(int i, iRegister * r)
        resets the i'th bit of the iRegister (to 0),
 
    int getBit(int i, iRegister * r);
        returns the i'th bit of the iRegister as an integer (1 if it is set, or 0 otherwise)
 
    void assignNibble(int pos, int i, iRegsiter * r)
        set the first (for pos=1) or the second (for pos=2) four bits of iRegsiter
 
    int getNibble(int pos, iRegsiter * r)
        get the first (for pos=1) or the second (for pos=2) four bits of iRegsiter
 
 
    void setAll(iRegister * r);
        sets all the bits of the iRegister (to 1),
 
    void resetAll(iRegister * r);
        resets all the bits of the iRegister (to 0),
 
    char * reg2str(iRegister r)
        returns a pointer to an array of 32 characters, with each character representing the corresponding bit of the iRegister, i.e., if the bit is set, then the character is "1" (ASCII char with code 49), or otherwise is "0" (ASCII char with code 48)
 
 
    void shiftRight(int n, iRegister * r);
        shifts all the bits of the iRegister to the right by n palces (appends 0 from the left)

    void shiftLeft(int n, iRegister * r);
        shifts all the bits of the iRegister to the left by n palces (appends 0 from the right)
 
 */

/*
 For each function write in comments:
 
 pre-condition: what should the input paramters represent / satisfy
 post-condition: what will hold after calling the function
 properties: specify at least some properties that the function should satisfy; see the remainder for concrete examples
 test-cases: write at least 6 test-cases representing different combination of allowed / forbidden inputs and their ouputs; at least one of the test-cases should be an instance of the specified properties
 
 */





typedef struct{
    int content;
} iRegister;



/* 
 
 void resetBit(int i, iRegister * r)
 
 pre-condition: 0 <= i < 32 and iRegister != Null
 
 post-condition: after reseti(i, r) the i'th bit of iRegister is 0, all other bits remain unchanged
 properties: 
 
    after resetBit(i, r),  getBit(i, r) = 0
 
    if getBit(i, r) == 0
        then getBit(j, r) reutrns the same value for all 0 <= j < 32 and j <> i before and after resetBit(i, r)

 
 test-cases: 
    1,2,3. Allocate memory to an iRegister r
    first do resetAll(&r),
    then set the i'th bit of &x by setBit(i, &r) for i = 0, 15 and 23 and then
    display the result after each and every call by 
       printf("%s",reg2str(r))
 
 
 */


void setBit(int, iRegsiter *)
void resetBit(int, iRegister *)
int getBit(int, iRegister *);


void assignNibble(int, int, iRegsiter *)
int getNibble(int, iRegsiter *)


void setAll(iRegister *);
void resetAll(iRegister *);

char * reg2str(iRegister)

void shiftRight(int, iRegister *);
void shiftLeft(int, iRegister *);


#endif
